/* Genesis */
/* by David Burden */
/* v0.10 Nov 90 */
/* Lattice C V5 */
/* STarport File Loading */
/* All text in string file */
/* Streamlined filewrite, suppress added */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
/*#include <dos.h>*/
#include <time.h>
#include "genprg.h"

FILE *fp;
int numstrings = 0;
int numlines = 0;
char *lines[MAXSTRINGS];
STRDEF strptr[MAXSTRINGS];
ECPDEF ecp[] = {
   0, 0, 0, "ba",
   0, 0, 0, "sp",
   0, 0, 0, "lp",
   0, 0, 0, "fg",
   0, 0, 0, "sa",
   0, 0, 0, "cr",
   0, 0, 0, "in",
   0, 0, 0, "fi",
   0, 0, 0, "fc",
   0, 0, 0, "am",
   0, 0, 0, "la3",
   0, 0, 0, "la4",
   0, 0, 0, "la5",
   0, 0, 0, "la6",
   0, 0, 0, "la7",
   0, 0, 0, "la8",
   0, 0, 0, "fl1",
   0, 0, 0, "fl2",
   0, 0, 0, "fl3",
   0, 0, 0, "fl4",
   0, 0, 0, "fl5",
   0, 0, 0, "fl6",
   0, 0, 0, "hf"
};
int filewrite = FALSE;
int suppress = FALSE;
int runs = 1;
char uwp[9];
int uwpset = FALSE;
int abbrev = FALSE;
int prelife = FALSE;
   
void main(argc, argv)
char *argv[];
int argc;
{
   int LoadText();
   void OutputCode(), GenerateECP(), DisplayECP(), GenerateUWP();
   void OutputString();
   int Arguements();
   extern int filewrite, runs, uwpset;
   int loop, valid, quit;
   int wantedhelp = FALSE;
   
   srand((unsigned int)(time(NULL)));
   valid = LoadText();
  	if (valid && (argc > 1)) {
   	wantedhelp = Arguements(argc, argv);
		if (wantedhelp)
			valid = FALSE;
	}   	    
   if (valid) {
   	OutputString("\n", TRUE);
      OutputCode("zz0", TRUE);
      quit = FALSE;
      do {
         for (loop = 0; loop < runs; loop++) {
            OutputString("\n", TRUE);
            if (!uwpset)
            	GenerateUWP();
            GenerateECP();
            DisplayECP();
            OutputString("\n", TRUE);
         }
         if (!filewrite) {
         	OutputCode("zz1", TRUE);
            if (getch() != 'y')
               quit = TRUE;
         } else {
            quit = TRUE;
         }
      } while (!quit);
   } else {
   	if (!wantedhelp) {
      	puts("\nError: Cannot load GENESIS.STR text file!\n");
      	(void)getch();
     	}
   }
   if (filewrite)
      (void)fclose(fp);
}

int LoadText()
/* modified to also load a value */
{
	int loadfile(), hexctoi();
   extern STRDEF strptr[];
   extern char *lines[];
   extern int numstrings, numlines;
   int loop, iloop, done, error;
   int valid = TRUE;
   
   error = FALSE;
   numstrings = 0;
   numlines = loadfile("genesis.str", lines);
	if (numlines < 1) {            
      valid = FALSE; 
	} else {                     
    	valid = TRUE;
      for(loop = 0; loop < numlines; loop++ ) {
			if (lines[loop][0] == ':') {
				iloop = 1;
				done = FALSE;
				do {
					if (lines[loop][iloop] == ':') {
						lines[loop][iloop] = '\0';
						strptr[numstrings].idx = &lines[loop][1];
						if (lines[loop][iloop + 2] == ':') {
							strptr[numstrings].val = hexctoi(lines[loop][iloop + 1]);
							strptr[numstrings].txt = &lines[loop][iloop + 3];
						} else {
							strptr[numstrings].val = -1;
							strptr[numstrings].txt = &lines[loop][iloop + 1];
						}
						numstrings++;
						done = TRUE;
					}
					iloop++;
				} while ((lines[loop][iloop] != '\0') && !done);
			}
		}
   }
   return(valid);
}


int rnd(dice)
int dice;
{
   int val;
   unsigned int c1, c2;

   dice = (dice < 2) ? 2 : dice;
   dice = (dice > 256) ? 256 : dice;
   c1 = rand();
   c2 = c1 % 100000;
   c1 = c2 * dice / 100000;
   val = c1;
   val++;
   return(val);
}
   			
int TgtVal(cde)
char *cde;
{
	extern STRDEF strptr[];
	extern int numstrings;
	int val, loop;
	int found = FALSE;
	
   loop = 0;
   do {
   	if (!strcmp(strptr[loop].idx, cde)) {
      	val = strptr[loop].val;
      	found = TRUE;
     	}
     	loop++;
   } while ( loop < numstrings);
   
   if (!found) {
   	val = 999;
   }
   return(val);
}
   
void DisplayECP()
{
	void OutputCode(), OutputString();
   char *itoa();
   extern STRDEF string[];
   extern ECPDEF ecp[];
   extern int numstrings, abbrev;
   char val[7], target[5], *p;
   int loop, iloop, life, temp;
   life = FALSE;
  
   for (loop = 0; loop < NUMPARAM; loop++) {
   	if (ecp[loop].value != 0) {
   		life = TRUE;
      	/* match line */
      	if (loop <= LANDAN ) {
      		if (!abbrev) {
      			for(iloop = 1; iloop <= ecp[loop].value; iloop++) {
      				p = strcpy(target, ecp[loop].code);
      				(void)itoa(iloop, val);
      				p = strcat(target, val);
      				OutputCode(target, FALSE);
      				OutputString("/", FALSE);
      				p = strcpy(target, "po");
      				temp = min((ecp[loop].pop + ecp[loop].value - iloop), ABUNDANT); 
      				(void)itoa(temp, val);
      				p = strcat(target, val);
      				OutputCode(target, TRUE);
      			}
      		} else {
      			p = strcpy(target, ecp[loop].code);
      			(void)itoa(ecp[loop].value, val);
      			p = strcat(target, val);
      			OutputCode(target, FALSE);
      			OutputString("    ", FALSE);
      			p = strcpy(target, "po");
      			(void)itoa(ecp[loop].pop, val);
      			p = strcat(target, val);
      			OutputCode(target, TRUE);
      		}
      	} else {
      		p = strcpy(target, ecp[loop].code);
      		OutputCode(target, FALSE);
      		OutputString("    ", FALSE);
      		p = strcpy(target, "po");
      		(void)itoa(ecp[loop].pop, val);
      		p = strcat(target, val);
      		OutputCode(target, TRUE);
      	}
      }
   }
   if (!life)
   	OutputCode("no");
}
   
char *itoa(val, buf)
char *buf;
int val;
{
   int loop, ptr, fac, started;
   
   started = FALSE;
   ptr = 0;
   if (val < 0) {
      buf[0] = '-';
      ptr = 1;
      val = -1 * val;
   }
   for(loop = 100000; loop > 1; loop = loop / 10) {
      fac = (int)(val / loop);
      if ((fac > 0) || started) {
         started = TRUE;
         buf[ptr] = '0' + fac;
         ptr++;
         val = val % loop;
      }
   }
   buf[ptr] = '0' + val;
   ptr++;
   buf[ptr] = '\0';
   return(buf);
}

int Arguements(argc, argv)
int argc;
char *argv[];
{
   void OutputString(), OutputCode(), OutputCodeStub();
   extern FILE *fp;
   extern int filewrite, suppress, runs, uwpset;
   extern int abbrev, prelife;
   extern char uwp[];
   char helpstr[5];
   int loop;
   int wantedhelp = FALSE;
   int wantssuppress = FALSE;
   char *p;

   for(loop = 1; loop < argc; loop++) {
      if (argv[loop][0] == '-') {
         /* parameter */
         switch (argv[loop][1]) {

				case 's':
					wantssuppress = TRUE;
					break;
					
            case 'n':
               runs = atoi(&argv[loop][2]);
               break;
            
            case 'u':
               p = strcpy(uwp, &argv[loop][2]);
               uwpset = TRUE;
               break;
               
            case 'a':
            	abbrev = TRUE;
            	break;
            	
            case 'p':
            	prelife = PROTOZOA;
            	break;
            	
            case 'l':
            	prelife = BACTERIA;
            	break;
            
            case 'o':
               fp = fopen(&argv[loop][2], "w");
               if (fp == NULL) {
                  OutputCode("zz4", TRUE);
                  OutputString("\n\n", TRUE);
                  OutputCode("zz5", TRUE);
                  OutputString("\n", TRUE);
                  (void)getchar();
               } else {
                  filewrite = TRUE;
               }
               break;

            case 'h':
               if (argv[loop][2] == 0) {
                  p = strcpy(helpstr, HELPCODE);
               } else {
                  p = strcpy(helpstr, &argv[loop][2]);
               }
               wantedhelp = TRUE;
               break;
         }
      }
   }
   if (wantssuppress && filewrite)
   	suppress = TRUE;
   if (wantedhelp) {
   	OutputCodeStub(helpstr, TRUE);
   	if (!filewrite) {
        	OutputString("\n", TRUE);
        	OutputCode("zz5", TRUE);
        	OutputString("\n", TRUE);
        	(void)getchar();
      } 
   }       	
   return(wantedhelp);
}

void GenerateUWP()
{
   char itohexc();
   int rnd(), hexctoi();
   extern char uwp[];
   int val;

   val = rnd(6) + rnd(6);
   uwp[UWPPORT] = 'X';
   if (val > 1)
      uwp[UWPPORT] = 'A';
   if (val > 4)
      uwp[UWPPORT] = 'B';
   if (val > 6)
      uwp[UWPPORT] = 'C';
   if (val > 8)
      uwp[UWPPORT] = 'D';
   if (val > 9)
      uwp[UWPPORT] = 'E';
   uwp[UWPSIZE] = itohexc(rnd(6) + rnd(6) - 2);
   if (uwp[UWPSIZE] == '0') {
      uwp[UWPATMOS] = '0';
   } else {
      uwp[UWPATMOS] = rnd(6) + rnd(6) - 7 + hexctoi(uwp[UWPSIZE]);
   }
   if (hexctoi(uwp[UWPSIZE]) <= 1) {
      uwp[UWPHYDRO] = '0';
   } else {
      val = rnd(6) + rnd(6) - 7 + hexctoi(uwp[UWPSIZE]);
      if (hexctoi(uwp[UWPATMOS]) <= 1)
         val -= 4;
      if (hexctoi(uwp[UWPATMOS]) >= 10)
         val -= 4;
      uwp[UWPHYDRO] = itohexc(val);
   }
   uwp[UWPPOP] = itohexc(rnd(6) + rnd(6) - 2);
   uwp[UWPGOV] = itohexc(rnd(6) + rnd(6) - 7 + hexctoi(uwp[UWPPOP]));
   uwp[UWPLAW] = itohexc(rnd(6) + rnd(6) - 7 + hexctoi(uwp[UWPGOV]));
   val = rnd(6); 
   if (uwp[UWPPORT] == 'A')
      val += 6;
   if (uwp[UWPPORT] == 'B')
      val += 4;
   if (uwp[UWPPORT] == 'C')
      val += 2;
   if (uwp[UWPPORT] == 'X')
      val -= 4;
   if (hexctoi(uwp[UWPSIZE]) < 5)
      val++;
   if (hexctoi(uwp[UWPSIZE]) < 2)
      val++;
   if (hexctoi(uwp[UWPATMOS]) < 4)
      val++;
   if (hexctoi(uwp[UWPATMOS]) > 9)
      val++;
   if (uwp[UWPHYDRO] == '9')
      val++;
   if (uwp[UWPHYDRO] == 'A')
      val += 2;
   if ((hexctoi(uwp[UWPPOP]) >= 1) && (hexctoi(uwp[UWPPOP]) <= 5))
      val++;
   if (uwp[UWPPOP] == '9')
      val += 2;
   if (uwp[UWPPOP] == 'A')
      val += 4;
   if (uwp[UWPGOV] == '0')
      val++;
   if (uwp[UWPGOV] == '5')
      val++;
   if (uwp[UWPGOV] == 'D')
      val -= 2;
   uwp[UWPTECH] = itohexc(val);
}

int IsHi()
{
	extern char uwp[];
	int val;
	
	if (hexctoi(uwp[UWPPOP]) >= 9) {
		val = TRUE;
	} else {
		val = FALSE;
	}
	return(val);
}

int IsAg()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if ((hexctoi(uwp[UWPATMOS]) < 4) || (hexctoi(uwp[UWPATMOS]) > 9)) 
		val = FALSE;
	if ((hexctoi(uwp[UWPHYDRO]) < 4) || (hexctoi(uwp[UWPHYDRO]) > 8)) 
		val = FALSE;
	if ((hexctoi(uwp[UWPPOP]) < 5) || (hexctoi(uwp[UWPPOP]) > 7)) 
		val = FALSE;
	return(val);
}

int IsSmall()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if (hexctoi(uwp[UWPSIZE]) > 4) 
		val = FALSE;
	return(val);
}

int IsLarge()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if (hexctoi(uwp[UWPSIZE]) < 8)
		val = FALSE;
	return(val);
}

int IsVacuum()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if (hexctoi(uwp[UWPATMOS]) > 3)
		val = FALSE;
	return(val);
}

int IsIn()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if ((hexctoi(uwp[UWPATMOS]) < 2) || (hexctoi(uwp[UWPATMOS]) > 4))
		val = FALSE;
	if (hexctoi(uwp[UWPATMOS]) == 7)
		val = TRUE;
	if (hexctoi(uwp[UWPATMOS]) == 9)
		val = TRUE;
	if (hexctoi(uwp[UWPPOP]) < 9)
		val = FALSE;
	return(val);
}

int IsNi()
{
	extern char uwp[];
	int val;
	
	val = TRUE;
	if (hexctoi(uwp[UWPPOP]) > 6)
		val = FALSE;
	return(val);
}

int IsDesert()
{
	extern char uwp[];
	int val;
	
	val = FALSE;
	if (uwp[UWPHYDRO] == '0')
		val = TRUE;
	return(val);
}
 
int IsDry()
{
	extern char uwp[];
	int val;
	
	val = FALSE;
	if ((hexctoi(uwp[UWPHYDRO]) == 1) || (hexctoi(uwp[UWPHYDRO]) == 2))
		val = TRUE;
	return(val);
}

int IsWater()
{
	extern char uwp[];
	int val;
	
	val = FALSE;
	if (uwp[UWPHYDRO] == 'A')
		val = TRUE;
	return(val);
}

int hexctoi(txt)
char txt;
{
   int val;
   
   if ((txt >= '0') && (txt <= '9')) {
      val = (int)(txt - '0');
   } else {
      val = (int)(txt - 'A' + 10);
   }
   val = (val < 0) ? 0 : val;
   return(val);
}

char itohexc(val)
int val;
{
   char fig;
   
   if ((val >= 0) && (val <= 9)) {
      fig = '0' + val;
   } else {
      fig = 'A' + val - 10;
   }
   return(fig);
}

/* fol is modified from Starport release */

int loadfile(name, lines)
char *name, *lines[];
{
	int error, blocks; 
	int length, i; 
	FILE *fp;
	size_t a; 
	char *area, *p;

	fp = fopen(name, "rb");			if(fp == NULL)return(-1);
	error = fseek(fp, 0, SEEK_END);	if(error == -1)return(-2);
	length = ftell(fp);				if(length == -1L)return(-3);
	error = fseek(fp, 0, SEEK_SET);	if(error == -1)return(-4);
	blocks = length % 512;
	area = malloc(length + 512);	if(area == NULL)return(-5);
	a = fread(area, 512, blocks, fp);	if(a == -1)return(-6);
	error = fclose(fp);				if(error == -1)return(-7);

	i = 0;
	lines[i] = area;

	for (p = area; p < (area+length); ) {
		if (*p == '\n' || *p == '\r') {
			*p++ = '\0';
			/* p++; */
			lines[++i] = p;
		} else {
			p++;
		}
	}
	lines[++i] = NULL;
	return(i - 1);
}

void OutputCode(code, cr)
char *code;
int cr;
{
	extern STRDEF strptr[];
	extern int numstrings;
	static int recurse = FALSE;
	int loop;
	int found = FALSE;
	
   loop = 0;
   do {
   	if (!strcmp(strptr[loop].idx, code)) {
   		OutputString(strptr[loop].txt, cr);
      	found = TRUE;
      	recurse = FALSE;
     	}
     	loop++;
   } while ( loop < numstrings);
   
   if (!found) {
  		if (!recurse) {
	  		recurse = TRUE;
  			OutputCode("zz3", cr);
  		} else {
  			recurse = FALSE;
  			OutputString("Error: String not Found", TRUE);
  		}
  	}
}

void OutputString(txt, cr)
char *txt;
int cr;
{
	extern FILE *fp;
	extern int filewrite, suppress;

	if (!suppress) {
		if (cr) {  		
  			puts(txt);
  		} else {
  			printf("%s", txt);
  		}
  	}
  	if (filewrite) {
  		fputs(txt, fp);
  		if (cr)
  			fputs("\n", fp);
  	}
}

void OutputChar(cter)
char cter;
{
	extern FILE *fp;
	extern int filewrite, suppress;

	if (!suppress)  		
  		putchar(cter);
  	if (filewrite) {
  		fputc(cter, fp);
  	}
}
  	
void OutputCodeStub(code)
char *code;
{
	extern STRDEF strptr[];
	extern int numstrings;
	static int recurse = FALSE;
	int loop;
	int found = FALSE;
	
   loop = 0;
   do {
   	if (!strncmp(strptr[loop].idx, code, 2)) {
   		OutputString(strptr[loop].txt);
      	found = TRUE;
      	recurse = FALSE;
     	}
     	loop++;
   } while ( loop < numstrings);
   
   if (!found) {
  		if (!recurse) {
	  		recurse = TRUE;
  			OutputCode("zz3");
  		} else {
  			recurse = FALSE;
  			OutputString("Error: String not Found");
  		}
  	}
}
  	
#ifndef MSDOS
int getch() {
    int charact, ch;
    while ((ch=getchar()) != '\n') {
    charact=ch;
    }
    return charact;
}
#endif 
      



