/* Genesis */
/* by David Burden */
/* v0.10 Nov 90 */
/* Lattice C V5 */
/* overlay 1 */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
/*#include <dos.h>*/
#include <time.h>
#include "genprg.h"

void GenerateECP()
{
   int rnd(), hexctoi(), TgtVal(), IsAg(), IsNa(), IsHi();
   int IsVacuum(), IsSmall(), IsLarge();
   void GeneratePop();
   extern ECPDEF ecp[];
   extern int uwpset, prelife;
   extern char uwp[];
   int loop, roll, level, margin, margin2;
   
   for( loop = 0; loop < NUMPARAM; loop++ ) {
   	ecp[loop].value = 0;
   	ecp[loop].pop = 0;
   }
   
   /* basic life */
   level = 0;
   roll = rnd(6) + rnd(6);
   if (IsDesert())
   	roll -= 4;
   if (IsDry())
   	roll -= 2;
   if (IsWater())
   	roll -= 2;
   margin = roll - TgtVal("ba1");
   if ((margin >= 0) || prelife) {
   	level = 1;
   	margin2 = margin;
   	roll = rnd(6) + rnd(6);
   	if (IsDesert())
   		roll -= 4;
   	if (IsDry())
   		roll -= 2;
   	if (IsWater())
   		roll -= 2;
   	margin = roll - TgtVal("ba2");
   	if ((margin >= 0) || prelife) {
   		level = 2;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsDesert())
   			roll -= 2;
   		if (IsDry())
   			roll--;
   		margin = roll - TgtVal("ba3");
   		if ((margin >= 0) || prelife) {
   			level = 3;
   			margin2 = margin;
   			roll = rnd(6) + rnd(6);
   			if (IsDesert())
   				roll -= 2;
   			if (IsVacuum())
   				roll -= 2;
   			margin = roll - TgtVal("ba4");
   			if ((margin >= 0) || (prelife == PROTOZOA)) {
   				level = 4;
   				margin2 = margin;
   				roll = rnd(6) + rnd(6);
   				if (IsDesert())
   					roll -= 2;
   				if (IsVacuum())
   					roll -= 4;
   				margin = roll - TgtVal("ba1");
   				if ((margin >= 0) || (prelife == PROTOZOA)) {
   					level = 5;
   					margin2 = margin;
   				}
   			}
   		}
   	}
   }
   ecp[BASIC].value = level;
   if (level != 0) {
   	if (prelife) {
   		ecp[BASIC].pop = ABUNDANT;
   	} else {
   		ecp[BASIC].pop = min(margin2 + 1, ABUNDANT);
   	}
   }
   	
	
	/* sea plants */
	if (ecp[BASIC].value == 5) {
		level = 0;
		roll = rnd(6) + rnd(6);
		if (IsDesert()) 
			roll -= 2;
		if (IsDry())
			roll--;
		if (IsAg())
			roll++;
   	if (IsHi())
   		roll++;
   	margin = roll - TgtVal("sp1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   	}
   	ecp[SEAPLANT].value = level;
   	if (level != 0)
   		ecp[SEAPLANT].pop = min(margin2 + 1, ABUNDANT);
   }
   
   /* land plants */
   if (ecp[BASIC].value == 5) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsWater())
   		roll--;
   	if (IsAg())
   		roll++;
   	if (IsHi())
   		roll++;
   	margin = roll - TgtVal("lp1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsWater())
   			roll--;
   		if (IsAg())
   			roll++;
   		if (IsHi())
   			roll++;
   		margin = roll - TgtVal("lp2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin;
   			roll = rnd(6) + rnd(6);
   			if (IsWater())
   				roll--;
   			if (IsAg())
   				roll++;
   			if (IsHi())
   				roll++;
   			margin = roll - TgtVal("lp3");
   			if (margin >= 0) {
   				level = 3;
   				margin2 = margin;
   				roll = rnd(6) + rnd(6);
   				if (IsWater())
   					roll--;
   				if (IsAg())
   					roll++;
   				if (IsHi())
   					roll++;
   				margin = roll - TgtVal("lp4");
   				if (margin >= 0) {
   					level = 4;
   					margin2 = margin;
   				}
   			}
   		}
   	}
   	ecp[LANDPLANT].value = level;
   	if (level != 0)
   		ecp[LANDPLANT].pop = min(margin2 + 1, ABUNDANT);
   }
   
   /* fungi */
   if (ecp[LANDPLANT].value >= 1) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	if (IsHi())
   		roll++;
   	margin = roll - TgtVal("fg1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsWater())
   			roll--;
   		if (IsAg())
   			roll++;
   		if (IsHi())
   			roll++;
   		if (ecp[LANDPLANT].value >= 2)
   			roll++;
   		margin = roll - TgtVal("fg2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin;
   		}
   	}
   	ecp[FUNGI].value = level;
   	if (level != 0)
   		ecp[FUNGI].pop = min(margin2 + 1, ABUNDANT);
   }
   
   /* sea animals */
   if (ecp[BASIC].value == 5) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsDesert())
   		roll -= 2;
   	if (IsDry())
   		roll--;
   	margin = roll - TgtVal("sa1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsDesert())
   			roll -= 2;
   		if (IsDry())
   			roll--;
   		if (IsAg())
   			roll++;
   		margin = roll - TgtVal("sa2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin;
   			roll = rnd(6) + rnd(6);
   			if (IsDesert())
   				roll -= 2;
   			if (IsDry())
   				roll--;
   			if (IsAg())
   				roll++;
   			margin = roll - TgtVal("sa3");
   			if (margin >= 0) {
   				level = 3;
   				margin2 = margin;
   				roll = rnd(6) + rnd(6);
   				if (IsDesert())
   					roll -= 2;
   				if (IsDry())
   					roll--;
   				if (IsAg())
   					roll++;
   				margin = roll - TgtVal("sa4");
   				if (margin >= 0) {
   					level = 4;
   					margin2 = margin;
   					roll = rnd(6) + rnd(6);
   					if (IsDesert())
   						roll -= 4;
   					if (IsDry())
   						roll--;
   					if (IsAg())
   						roll++;
   					margin = roll - TgtVal("sa5");
   					if (margin >= 0) {
   						level = 5;
   						margin2 = margin;
   						roll = rnd(6) + rnd(6);
   						if (IsDesert())
   							roll -= 6;
   						if (IsDry())
   							roll -= 2;
   						if (IsAg())
   							roll++;
   						margin = roll - TgtVal("sa6");
   						if (margin >= 0) {
   							level = 6;
   							margin2 = margin;
								roll = rnd(6) + rnd(6);
								if (IsDesert())
   								roll -= 6;
   							if (IsDry())
   								roll -= 2;
								if (IsAg())
   								roll++;
   							margin = roll - TgtVal("sa7");
   							if (margin >= 0) {
   								level = 7;
   								margin2 = margin;
   							}
   						}
   					}
   				}
   			}
   		}
   	}
   	ecp[SEAAN].value = level;
   	if (level != 0)
   		ecp[SEAAN].pop = min(1 + margin2, ABUNDANT);
   }
   
   /* redo protosa population */
   
   if (ecp[BASIC].value == 5) {
   	if ((ecp[SEAPLANT].value >= 1) || (ecp[LANDPLANT].value >= 1) || (ecp[SEAAN].value >= 1))
   		ecp[BASIC].pop = ABUNDANT;
   }
    
   /* crustacea */
   
   if (ecp[SEAAN].value >= 4) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsDesert())
   		roll += 2;
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("cr1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsDesert())
   			roll += 4;
   		if (IsAg())
   			roll++;
   		margin = roll - TgtVal("cr2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin;
   		}
   	}
   	ecp[CRUST].value = level;
   	if (level != 0)
   		ecp[CRUST].pop = min(1 + margin2, ABUNDANT);
   }
   /* do spiders after insects */
   /* insects */
   
   if ((ecp[CRUST].value >= 2) && (ecp[LANDPLANT].value >= 2) ) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsWater())
   		roll -= 2;
   	if (IsDesert())
   		roll += 4;
   	margin = roll - TgtVal("in1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsWater())
   			roll -= 2;
   		if (IsDesert())
   			roll += 2;
   		margin = roll - TgtVal("in2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin; 
   			if ( ecp[LANDPLANT].value >= 3 ) {
   				roll = rnd(6) + rnd(6);
   				if (IsWater())
   					roll -= 2;
   				margin = roll - TgtVal("in3");
   				if (margin >= 0) {
   					level = 3;
   					margin2 = margin;
   				}
   			}
   		}
   	}
   	ecp[INSECTS].value = level;
   	if (level != 0)
   		ecp[INSECTS].pop = min(1 + margin2, ABUNDANT);
   }
   
   /* angiosperms */
   if ((ecp[INSECTS].value == 3) && (ecp[LANDPLANT].value == 4)) {
   	roll = rnd(6) + rnd(6);
   	if (IsWater())
   		roll--;
   	if (IsAg())
   		roll++;
   	if (IsHi())
   		roll++;
   	margin = roll - TgtVal("lp5");
   	if (margin >= 0) {
   		margin2 = margin;
   		ecp[LANDPLANT].value = 5;
   		ecp[LANDPLANT].pop = min(1 + margin2, ABUNDANT);
   	}
   }

	/* hydrocarbon fuels */
	if (ecp[LANDPLANT].value >= 3) {
		roll = rnd(6) + rnd(6);
		if (ecp[LANDPLANT].value == 4)
			roll++;
		if (ecp[LANDPLANT].value == 5)
			roll++;
		if (IsIn())
			roll++;
		if (IsNi())
			roll--;
		margin = roll - TgtVal("hf");
		if (margin >= 0) {
			ecp[HYDROCFUEL].value = 1;
			margin2 = margin;
			ecp[HYDROCFUEL].pop = min(margin2 + 1, ABUNDANT);
		}
	}
	   
   /* now do spiders */
   if (ecp[INSECTS].value >= 1) {
   	roll = rnd(6) + rnd(6);
   	if (IsWater())
   		roll--;
   	if (IsDesert())
   		roll += 2;
   	margin = roll - TgtVal("cr3");
   	if (margin >= 0) {
   		ecp[CRUST].value = 3;
   		margin2 = margin;
   		ecp[CRUST].pop = min(margin2 + 1, ABUNDANT);
   	}
   }
   
   if (ecp[SEAAN].value >= 4) {
   	level = 0;
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("fi1");
   	if (margin >= 0) {
   		level = 1;
   		margin2 = margin;
   		roll = rnd(6) + rnd(6);
   		if (IsDesert())
   			roll--;
   		if (IsAg())
   			roll++;
   		margin = roll - TgtVal("fi2");
   		if (margin >= 0) {
   			level = 2;
   			margin2 = margin;
   			roll = rnd(6) + rnd(6);
   			if (IsDesert())
   				roll--;
   			if (IsAg())
   				roll++;
   			margin = roll - TgtVal("fi3");
   			if (margin >= 0) {
   				level = 3;
   				margin2 = margin;
   				roll = rnd(6) + rnd(6);
   				if (IsDesert())
   					roll -= 4;
   				if (IsDry())
   					roll--;
   				if (IsAg())
   					roll++;
   				margin = roll - TgtVal("fi4");
   				if (margin >= 0) {
   					level = 4;
   					margin2 = margin;
   					roll = rnd(6) + rnd(6);
   					if (IsDesert())
   						roll -= 4;
   					if (IsDry())
   						roll -= 2;
   					if (IsAg())
   						roll++;
   					margin = roll - TgtVal("fi5");
   					if (margin >= 0) {
   						level = 5;
   						margin2 = margin;
   					}
   				}
   			}
   		}
   	}
   	ecp[FISH].value = level;
   	if (level != 0)
   		ecp[FISH].pop = min(1 + margin2, ABUNDANT);
   }
   
   /* sharks */
   if (ecp[FISH].value >= 4) {
   	roll = rnd(6) + rnd(6);
   	if (IsDesert())
   		roll -= 4;
   	if (IsDry())
   		roll -= 2;
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("fc1");
   	if (margin >= 0) {
   		ecp[CART].value = 1;
   		margin2 = margin;
   		ecp[CART].pop = min(1 + margin2, ABUNDANT);
   	}
   }
   
   if (ecp[LANDPLANT].value >= 2) {
   	if ((ecp[FISH].value >= 5) || (IsDesert() && (ecp[FISH].value >= 3))) {
   		level = 0;
   		roll = rnd(6) + rnd(6);
   		if (IsWater())
   			roll--;
   		if (IsDesert())
   			roll++;
   		if (IsAg())
   			roll++;
   		if (ecp[INSECTS].value >= 2)
   			roll++;
   		margin = roll - TgtVal("am1");
   		if (margin >= 0) {
   			level = 1;
   			margin2 = margin;
   		}
   		ecp[LANDAN].value = level;
   		if (level != 0)
   			ecp[LANDAN].pop = min(1 + margin2, ABUNDANT);
   	}
   }
   if (ecp[LANDAN].value == 1) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la3");
   	if (margin >= 0) {
   		ecp[ECTOEGG].value = 1;
   		ecp[ECTOEGG].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl1");
   			if (margin >= 0) {
   				ecp[FECTOEGG].value = 1;
   				ecp[FECTOEGG].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
   if (ecp[LANDAN].value == 2) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la4");
   	if (margin >= 0) {
   		ecp[ECTOPLA].value = 1;
   		ecp[ECTOPLA].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl2");
   			if (margin >= 0) {
   				ecp[FECTOPLA].value = 1;
   				ecp[FECTOPLA].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
   if (ecp[LANDAN].value == 2) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la5");
   	if (margin >= 0) {
   		ecp[ECTOMAR].value = 1;
   		ecp[ECTOMAR].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl3");
   			if (margin >= 0) {
   				ecp[FECTOMAR].value = 1;
   				ecp[FECTOMAR].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
   if (ecp[LANDAN].value == 2) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la6");
   	if (margin >= 0) {
   		ecp[ENDOEGG].value = 1;
   		ecp[ENDOEGG].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl4");
   			if (margin >= 0) {
   				ecp[FENDOEGG].value = 1;
   				ecp[FENDOEGG].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
   if (ecp[LANDAN].value == 2) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la7");
   	if (margin >= 0) {
   		ecp[ENDOPLA].value = 1;
   		ecp[ENDOPLA].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl5");
   			if (margin >= 0) {
   				ecp[FENDOPLA].value = 1;
   				ecp[FENDOPLA].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
   if (ecp[LANDAN].value == 2) {
   	roll = rnd(6) + rnd(6);
   	if (IsAg())
   		roll++;
   	margin = roll - TgtVal("la8");
   	if (margin >= 0) {
   		ecp[ENDOMAR].value = 1;
   		ecp[ENDOMAR].pop = min(1 + margin, ABUNDANT);
   		if ((ecp[LANDPLANT].value >= 4) && !IsVacuum()) {
   			roll = rnd(6) + rnd(6);
   			if (IsSmall())
   				roll++;
   			if (IsLarge())
   				roll--;
   			margin = roll - TgtVal("fl6");
   			if (margin >= 0) {
   				ecp[FENDOMAR].value = 1;
   				ecp[FENDOMAR].pop = min(1 + margin, ABUNDANT);
   			}
   		}
   	}
   }	
}
